# GUARDARA Installer

The GUARDARA installer is a single shell script to install, upgrade or uninstall GUARDARA. The complete list of capabilities can be obtained by running the installer with the `-h` option:

```
$ sudo ./install.sh -h

Usage: ./install.sh [-h|--help] [<command>]
Available commands:
  -i | install      :   Install GUARDARA Manager
  -r | remove       :   Uninstall GUARDARA Manager
  -s | start        :   Start GUARDARA Manager
  -x | stop         :   Stop GUARDARA Manager
  -u | upgrade      :   Upgrade to latest version (reinstall)
  -c | rotate       :   Rotate certificates
  -a | auth         :   Authenticate to GUARDARA registry

No <command> starts the interactive mode.
```

The installer script must be run as `root` (via `sudo`) as on Linux it automatically installs all the dependencies required to deploy GUARDARA.

## Deploying GUARDARA

### Manual Deployment and Configuration

Deploying GUARDARA is as easy as:

 1. Execute `sudo install.sh` and follow the instructions.
 2. Once GUARDARA is deployed, the setup pages can be accessed at `https://127.0.0.1:8443/`.

### Unattended Deployment and Configuration

GUARDARA supports unattended deployments. To deploy GUARDARA in a programmatic way, follow the steps below.

**Create Cloud-Init File**

Create the `cloud-init.yml` file that contains the initial configuration for GUARDARA. This file should be located right next to the installer script. Make sure to replace the variables (`${.*}`) shown below with actual values, such as the FQDN or IP address of the system and the administrator's initial credentials.

```
setup:
  fqdn: ${FQDN}
  admin_email: ${EMAIL}
  admin_password: ${RANDOM_PASSWORD}
```

The following optional settings are also supported under the `setup` key:

 * smtp_server: The hostname or IP address of the SMTP server.
 * smtp_port: The port number the SMTP server is listening on.
 * smtp_tls: Whether to enable or disable TLS. Default `true`.
 * smtp_username: The username to use to authenticate to the SMTP server.
 * smtp_password: The password to use to authenticate to the SMTP server.

**Run Installer**

Run the installer script to deploy GUARDARA.

```
$ sudo ./install.sh -i
```

The system is accessible at `https://${SYSTEM_IP_ADDRESS}:8443/` after the installer script completes. Make sure to change the administrator's password at the first login.
